# RN 打包


## compiler
调用 metro 进行打包, 使用 react-native 0.62.2+


### 打包:
```
compiler.compile = (options: Options) => Promise<CompileOutput[]>

type Platform = 'ios' | 'android'

export interface BundleConfig {
  entryAbsPath: string
  outputDir: string
  getBundleName?: (platform: Platform, entryAbsPath: string) => string,
  platforms?: Platform[]
}

export interface Options {
  projectRoot: string
  bundleConfigs: BundleConfig[]
  publicPath: string

  metroConfig?: MetroConfig
  filterModules?: Set<string>
}

export type CompileOutput = {
  entryAbsPath: string
  bundleAbsPath: string
  bundleMd5: string
}
```

### 本地服务
```
compiler.devServer = (config: MatrixServerConfig) => Promise<void>


export interface MatrixServerConfig {
  projectRoot: string

  metroConfig?: MetroConfig
  onRequest?: (queryUrl: string) => void | Promise<void>
  interactive?: boolean
}
```


### 获取 metro 配置

```
compiler.getDefaultConfig = (options: Options) => MetroConfig

type Options = {
  projectRoot: string
  filterModules: Set<string>
  mode: 'dev' | 'production'
  imageBaseURI?: string
}
```

## deprecatedCompiler

调用 react-native/local-cli 进行打包, 适用 react-native 0.58.5


### 打包:
```
deprecatedCompiler.compile = (options: CliOptions) => Promise<CompileOutput[]>


interface CliOptions {
  projectRoot: string
  metroConfigAbsPath: string
  bundleConfigs: BundleConfig[]
}

```


### 本地服务:
```
deprecatedCompiler.devServer = (options: CliOptions) => Promise<void>

type CliOptions = {
  projectRoot: string
  metroConfigAbsPath: string
}
```

### 在指定位置生成 metro 配置文件, 返回改文件的绝对路径

```
deprecatedCompiler.generateMetroCfg = (options: Options) => string

interface Options {
  projectRoot: string
  publicPath: string
  filterModulesPath: string
  mode: 'dev' | 'production'
  cfgOutputDir?: string
  useHyCSS?: boolean,
}

```

## utils

### generateBuildResult

### getRegisterComponents
