"use strict";
/*
 * 0.58 的 rn 版本, 本身代码是和 metro 绑定在一起的
 * 所以最保险的方式是直接调用官方的 cli 去完成打包
 * 这里仅仅是兼容而已, 本地开发应该会全面迁移到 0.62
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const child_process_1 = require("child_process");
const logger_1 = __importDefault(require("../lib/logger"));
function metroServer({ projectRoot, metroConfigAbsPath }) {
    logger_1.default.info('\n正在启动调试服务...\n');
    /*
     * react-native 必须在顶层的 ndoe_modules 下,否则 cli 不能正常工作
     * 项目跟目录之外的文件报hash未计算
     * 所以只需要查找顶层的路径即可
     */
    const cliPath = path_1.default.resolve(projectRoot, 'node_modules/react-native/local-cli/cli.js');
    if (!fs_extra_1.default.existsSync(cliPath)) {
        logger_1.default.error(`\ncli 文件不存在, 请在项目根目录下安装正确的RN版本:`);
        logger_1.default.error(`\nnpm i react-native@0.58.5[0.62.2]`);
        process.exit(1);
    }
    /*
     * 同步的进程, 可以接受键盘输入
     */
    return child_process_1.spawnSync('node', [
        cliPath,
        'start',
        '--projectRoot',
        projectRoot,
        '--config',
        metroConfigAbsPath,
    ], {
        cwd: projectRoot,
        stdio: 'inherit',
        shell: process.platform === 'win32',
    });
}
exports.default = metroServer;
