"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.utils = exports.deprecatedCompiler = exports.compiler = void 0;
const matrixCompile_1 = __importDefault(require("./matrix-compile/matrixCompile"));
const matrixServer_1 = __importDefault(require("./matrix-server/matrixServer"));
const metroCompile_1 = __importDefault(require("./deprecated-compile/metroCompile"));
const metroServer_1 = __importDefault(require("./depreacted-server/metroServer"));
const getDefaultConfig_1 = __importDefault(require("./matrix-config/getDefaultConfig"));
const generateMetroCfg_1 = __importDefault(require("./deprecated-compile/generateMetroCfg"));
const generateBuildResult_1 = require("./lib/generateBuildResult");
const getRegisterComponents_1 = require("./lib/getRegisterComponents");
exports.compiler = {
    compile: matrixCompile_1.default,
    devServer: matrixServer_1.default,
    getDefaultConfig: getDefaultConfig_1.default,
};
exports.deprecatedCompiler = {
    compile: metroCompile_1.default,
    devServer: metroServer_1.default,
    generateMetroCfg: generateMetroCfg_1.default,
};
exports.utils = {
    generateDevBuildResult: generateBuildResult_1.generateDevBuildResult,
    generateProdBuildResult: generateBuildResult_1.generateProdBuildResult,
    getRegisterComponents: getRegisterComponents_1.getRegisterComponents,
    getActualComponents: getRegisterComponents_1.getActualComponents,
};
