"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
const TerminalReporter_1 = __importDefault(require("metro/src/lib/TerminalReporter"));
const chalk_1 = __importDefault(require("chalk"));
const constants_1 = require("../constants");
class HyTerminalReporter extends TerminalReporter_1.default {
    constructor(terminal, reportEvent) {
        super(terminal);
        // @ts-ignore
        this.reportEvent = reportEvent;
    }
    _log(event) {
        if (event.type === 'dep_graph_loading') {
            // @ts-ignore
            this.terminal.log(chalk_1.default.yellow.bold(constants_1.MATRIX_READY_MESSAGE));
            return;
        }
        return super._log(event);
    }
    _logInitializing() {
        const logo = [
            String.raw ` __  __     __  __     __  __     ______    `,
            String.raw `/\ \_\ \   /\ \/\ \   /\ \_\ \   /\  __ \   `,
            String.raw `\ \  __ \  \ \ \_\ \  \ \____ \  \ \  __ \  `,
            String.raw ` \ \_\ \_\  \ \_____\  \/\_____\  \ \_\ \_\ `,
            String.raw `  \/_/\/_/   \/_____/   \/_____/   \/_/\/_/ `,
            String.raw `                                            `,
        ];
        // @ts-ignore
        this.terminal.log(chalk_1.default.yellow(logo.join("\n")));
    }
    setReportEvent(reportEvent) {
        // @ts-ignore
        this.reportEvent = reportEvent;
    }
    update(event) {
        super.update(event);
        // @ts-ignore
        if (this.reportEvent) {
            // @ts-ignore
            this.reportEvent(event);
        }
    }
}
exports.default = HyTerminalReporter;
