"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = __importDefault(require("fs-extra"));
const crypto_1 = __importDefault(require("crypto"));
function default_1(absPath) {
    return new Promise(function (resolve, reject) {
        const rs = fs_extra_1.default.createReadStream(absPath);
        const hash = crypto_1.default.createHash('md5');
        rs.on('data', hash.update.bind(hash));
        rs.on('end', () => {
            resolve(hash.digest('hex'));
        });
        rs.on('error', (err) => {
            reject(err);
        });
    });
}
exports.default = default_1;
