import { MetroConfig } from '../matrix-config/configTypes';
declare type Platform = 'ios' | 'android';
export interface BundleConfig {
    entryAbsPath: string;
    outputDir: string;
    assetsDir?: string;
    getBundleName?: (platform: Platform, entryAbsPath: string) => string;
    platforms?: Platform[];
}
export interface Options {
    projectRoot: string;
    bundleConfigs: BundleConfig[];
    imageBaseURL: string;
    SDKAlias: {
        [aliasName: string]: string[];
    };
    metroConfig?: MetroConfig;
    filterModules?: Set<string>;
    filterModulesVersion?: Set<string>;
    extUuid?: string;
    cacheVersion?: string;
}
export declare type CompileOutput = {
    entryAbsPath: string;
    bundleAbsPath: string;
    bundleMd5: string;
    platform: Platform;
};
export default function compile({ projectRoot, filterModules, filterModulesVersion, imageBaseURL, SDKAlias, metroConfig, bundleConfigs, extUuid, cacheVersion, }: Options): Promise<CompileOutput[]>;
export {};
