import matrixCompile from './matrix-compile/matrixCompile'
import matrixServer from './matrix-server/matrixServer'

import metroCompile from './deprecated-compile/metroCompile'
import metroServer from './depreacted-server/metroServer'

import getDefaultConfig from './matrix-config/getDefaultConfig'
import generateMetroCfg from './deprecated-compile/generateMetroCfg'

import { generateDevBuildResult, generateProdBuildResult } from './lib/generateBuildResult'
import { getRegisterComponents, getActualComponents } from './lib/getRegisterComponents'


export const compiler = {
  compile: matrixCompile,
  devServer: matrixServer,
  getDefaultConfig,
}

export const deprecatedCompiler = {
  compile: metroCompile,
  devServer: metroServer,
  generateMetroCfg,
}

export const utils = {
  generateDevBuildResult,
  generateProdBuildResult,

  getRegisterComponents,
  getActualComponents,
}
